
/* File TRACE.C
	Main function for the Refal Tracer.
	March 8 1987.
*/

# define DEFINE_EXTERNALS 1

# include "version.h"
# include "rasl.h"
# include "decl.h"
# include "cdecl.h"
# include "ddecl.h"
# include "macros.h"
# include "dmacro.h"
# include "fileio.h"
# include "ifunc.h"
# include "tfunc.h"
# include <time.h>


	/* initialized  to zero by default. */
static char def_imp [MAXWS + 1 + sizeof(long)];
static char def_stop [MAXWS + 1 + sizeof(long)];
static char def_nobreak [MAXWS + 1];

	/* main entry to Refal tracer. */
int main (argc, argv)
	int argc;
	char *argv[];
	{
	int i;

		/* print the version and copyright information. */
	printf (VERSION, "Tracer", _refal_build_version);
	printf ("Copyright: Refal Systems Inc.\n");

	gargc = 0;
	flags[0] = '\0';
	garg = (char **) malloc (argc * sizeof (char *));
	if (garg == NULL)
		{
		fprintf(stderr, "Error: Can\'t allocate memory.\n");
		exit (3);
		};
	garg [0] = NULL;

	for (i = 1; i < argc; i++)
		if (*argv[i] == '-') /* flags */
			strcat (flags,argv[i]);
		else garg[gargc++] = argv[i];


	/* Flags recognized by the Refal system (on PC):
			(July 3 1986. DT., September 2 1998. AN. )
		-n : upon normal stop print the number of steps.
		-v :   "   "   "   "   "   "    view field.
		-k :   "   "   "   "   "   "    content of the stock.
		-t :   "   "   "   "   "   "    elapsed time.
		-s :   "   "   "   "   "   "    maximum allocated storage.
		-a : all of the above.
		-i : ignore unresolved external references. 
		-lnnn : memory_limit,  memory = 512*sizeof(LINK)*memory_limit
	*/

		/* define labels IMP and STOP. */
	strcpy (def_imp, "IMP$");
	IMP_ = def_imp + MAXWS;
	*IMP_ = BUILT_IN;
	wrlong_to_mem (42L, (IMP_ + 1)); /* change this 42 if you change bif.c */
	strcpy (def_stop, "STOP$");
	STOP_ = def_stop + MAXWS;
	*STOP_ = BUILT_IN;
	wrlong_to_mem (43L, (STOP_ + 1)); /* change this 43 if you change bif.c */
		/* define NOBREAK_ */
	strcpy (def_nobreak, "NOBREAK$");
	NOBREAK_ = def_nobreak + MAXWS;
	*NOBREAK_ = NO_BREAK;

/*	memory_limit = 600;  /* about 4 meg. */
/*	memory_limit = 1200;  /* about 8 meg. */
/*	memory_limit = 1500;  /* about 10 meg. */
/*	memory_limit = 1800;  /* about 12 meg. */
/*	memory_limit = 2400;  /* about 16 meg. */
	memory_limit = 2800;  /* about 20 meg. */

        ri_memory();
	ri_init ();
	rd_init ();
	whens = time (NULL);
	ri_inter ();
	exit (0);
	}
