
# include "version.h"
# include "decl.h"
# include "macros.h"
# include "ifunc.h"
# include <time.h>


		/* Refal interpreter auxiliary function. */

	/* Memory allocation routines. */

# define NUM_OF_LINKS_AT_A_GULP 512
# define RI_MEMORY_LIMIT 2800
/* Real space is RI_MEMORY_LIMIT * sizeof (LINK) * NUM_OF_LINKS_AT_A_GULP */
		
LINK *ri_getmem ()
	{
	/*register*/ int i;
	/*register*/ LINK *q, *qn;
	LINK *first;

	 	/* allocate space for 512 links */
	q = (LINK *) malloc(NUM_OF_LINKS_AT_A_GULP * sizeof(LINK));
	if (q == NULL) return NULL;
	first = qn = q;
		/*	structure it.	*/
	i = NUM_OF_LINKS_AT_A_GULP;
	while (-- i) q = q -> foll = ++ qn;
	q -> foll = NULL;
	return first;
	}

static int memory_used = 0;
LINK *ri_fmout()
	{
	int error = 0;
	LINK *newp = NULL;

	if ((memory_limit > 0) && (memory_used >= memory_limit)) error = 11;
	else if ((newp = ri_getmem()) == NULL) error = 9;
	if (error)
		{
		if (lfm == NULL)
			{
			lfm = malloc(sizeof(LINK));
			/* 43 line. Not check result of malloc. Shura. 29.01.98 */
			if (NULL == lfm) {
			  fprintf (stderr, "No memory for module\n");
			  exit (1);
			}
			lfm->foll = NULL;
			}
			/* clear out the partially formed right side. */
		rdy(0);
		ri_out(2);
		ri_error(error);
		return NULL;
		}
	memory_used++; 
	return newp;
	}

	/* Stop function. */

int ri_stop ()
	{
	if (flags[0] != '\0')
		fprintf(ref_err_file(), "REFAL: NORMAL STOP.\n");
	ri_error(0);
	return 0;
	}


	/* IMP function. */
int ri_imp ()
	{
		/* if there is a freezer, freeze and return. */
	if (exists_freeze())
		{
		ri_frz (2); 
		return 0;
		}

		/* print message and call error (which calls exit()) */
	fprintf(ref_err_file(), "REFAL ERROR:  RECOGNITION IMPOSSIBLE\n");
	ri_error(12);
	return 0;
	}

extern FILE* ref_err_file();
int ri_error(code)
	int code;
	{
	FILE *ferr = ref_err_file();
	long space, t;

# ifdef PCAT
	t = time (NULL);
	t -=  whens;
	/* 	if (code != 0) strcpy (flags, "a"); */
# endif

	ri_print_error_code(ferr, code);

# ifdef PCAT
	if (code != 0 && flags[0] == '\0')
		{
		char *token, line[100];

		fprintf(ferr, "Do you want to print view-field? [Yn]");
		fgets(line, sizeof(line)-1, stdin);
		token = strtok(line, " \n\t\f");
		if (token == NULL || *token == 'y' || *token == 'Y') strcpy(flags, "a");
		}
	if (strchr(flags, 'a'))
	  fprintf(ferr, VERSION, "System", _refal_build_version);
# endif

# ifdef PCAT
	if (strchr (flags, 'a') || strchr (flags, 'n'))
# endif
		fprintf(ferr, "*** Number of Steps = %2ld\n", nst);

# ifdef VMS
	/* On VAX/VMS the return code must be odd, otherwise the
		operating system complains. July 1 1986. DT. */
	code = 2*code + 1;
	if (code == 1) exit (code);
#endif

# ifdef PCAT
	if (strchr (flags, 't') || strchr (flags, 'a'))
		fprintf(ferr, "Elapsed system time: %ld seconds.\n", t);
# endif

# ifdef VMS
	if (code > 1)
		{
# else
# ifdef PCAT
	if (code > 0)
		{
# endif
# endif
		fprintf(ferr, "*** Active function: ");
		{
			char * cp_w = actfun - 1;

			for (cp_w --; * cp_w != '\0'; cp_w --);
			cp_w ++;
			ri_actput (cp_w, ferr);
		}
		/*ri_actput (actfun, ferr);*/
		putc ('\n', ferr);
		fprintf(ferr, "*** Active expression:\n");
		ri_putmb (tbel (1), tbel (2), ferr);
		};
# ifdef PCAT
	if (strchr (flags, 'a') || strchr (flags, 'v'))
# endif
	{
		fprintf(ferr, "*** The View Field:\n");
		ri_putmb (vf, vfend, ferr);
	};
# ifdef PCAT
	if (strchr (flags, 'a') || strchr (flags, 'k'))
# endif
		{
		fprintf(ferr, "*** Buried:\n");
		ri_putmb (stock, stock -> pair.b, ferr);
		};
# ifdef PCAT
	if (strchr (flags, 'a') || strchr (flags, 's'))
# endif
		{
		space = memory_used * sizeof (LINK) * NUM_OF_LINKS_AT_A_GULP;
		fprintf(ferr, "Memory allocated = %9ld Bytes\n", space);
		};
# ifdef PCAT
	if (flags[0] != '\0')
# endif
		putc ('\n', ferr);
	exit (code);
	return 0;
	}

	/* exploding or imploding functions. */

	/* Get the address of the compound symbol *s, assuming that *s
	consists of only upper-case letters, digits or underscore. */

char *ri_cs_impl (s)
	char *s;
	{
	int i;
	char *q;

	i = ri_hash (s);
	q = ri_cs_exist (i, s);
	if (q != NULL) return q;

	/* if we got here then the compound symbol was not found. */
	/* create it and insert it into the hast table. */

	q = malloc (strlen (s) + 1);
	/* 191 line. Not check result of malloc. Shura. 29.01.98 */
	if (NULL == q) {
	  fprintf (stderr, "No memory for string\n");
	  exit (1);
	}
	strcpy (q, s);
	ri_cs_ins (i, q);
	return q;
	}


char *ri_cs_exist (i, s)
	/* check to see if the compound symol is already in the table. */
	int i;
	char *s;
	{
	struct cshte *ptr;
	char *q;

	for (ptr = csht[i]; ptr != NULL; ptr = ptr -> next)
		{
		q = ptr -> cs;
		if (strcmp (s, q) == 0) return q;
		};
	return NULL;
	}

int ri_cs_ins (hv, q)
	/* insert the compound symbol q with hash value hv into the table. */
	int hv;
	char *q;
	{
	struct cshte *ptr;

	ptr = (struct cshte *) malloc (sizeof (struct cshte));
	/* 221 line. Not check result of malloc. Shura. 29.01.98 */
	if (NULL == ptr) {
	  fprintf (stderr, "No memory for symbols\n");
	  exit (1);
	}
	ptr -> cs = q;
	ptr -> next = csht[hv];
	csht[hv] = ptr;
	return 0;
	}

int ri_hash (s)
	char *s;
	
	{
	int base = 38, h = 0, i;

	while (*s != '\0')
		{
		switch (*s)
			{

			case '-':
			case '_':
				i = 36;
				break;

			case '$':
				i = 37;
				break;

			default:
				if (isupper (*s)) i = *s - 'A';
				else if (islower (*s)) i = *s - 'a';
				else if (isdigit (*s)) i = *s - '0' + 26;
				else return h;
			};
		s++;
		h = (h*base + i) % HASH_SIZE;
		};
	return h;
	}

int ri_print_error_code(fp, err_code)
	FILE *fp;
	int err_code;
	{
	if (err_code == 0) return 0;
	fprintf(fp, "Refal system Error: ");
	switch(err_code)
		{
		case 0:
			fprintf(fp, "Refal normal stop\n");
			break;
		case 1:
			fprintf(fp, "Memory allocation error\n");
			break;
		case 2:
			fprintf(fp, "File error.\n");
			break;
		case 3:
			fprintf(fp, "Error: Freeze occured and no Freezer found.\n");
			break;
		case 4:
			fprintf(fp, "Illegal instruction\n");
			break;
		case 5:
			fprintf(fp, "Error in FREEZER.\n");
			break;
		case 6:
			fprintf(fp, "Error in Freezer metacode.\n");
			break;
		case 7:
			fprintf(fp, "Error in function MU\n");
			break;
		case 8:
			fprintf(fp, "Format error in built-in function.\n");
			break;
		case 9:
			fprintf(fp, "No more free memory\n");
			break;
		case 10:
			fprintf(fp, "Unknown link type.\n");
			break;
		case 11:
			fprintf(fp, "Memory limit reached\n");
			fprintf(fp, "Memory limit: %9ld \n",memory_limit);
			fprintf(fp,"Memory used: %9ld\n",memory_used);
			break;
		case 12:
			fprintf(fp, "Recognition impossible.\n");
			break;
		default:
			fprintf(fp, "Error code %d\n", err_code);
			break;
		}
	return 0;
	}

int ri_memory()
	{
	long limit = 0;
	char * fl = flags;
	
        printf("Flags: %s",fl);
	while( ((* fl) != '\0') || !( ((* fl) == '-') && ((* ++fl) == 'l') )
	     ) fl++;
	
	/* -lnnn -- memory_limit */
	if ((* fl) == 'l')
	   { while( ((* ++fl) != '\0') && isdigit(* fl) ) 
                  { limit = (limit + ((* fl) - '0') ) * 10; }
           }
        else { limit = RI_MEMORY_LIMIT; }           
        memory_limit = limit;
        printf("Memory limit: %ld",memory_limit);
        return 0;
        }
